//Excel.cpp
#include "stdafx.h"

#include <iostream>
#include <cmath>
#include <string>
#include <assert.h>

extern void OutputDebugPrintf(char* fmt, ...);

//#define MY_EXCEL_POSITION

#import \
"C:\Program Files\Common Files\Microsoft Shared\OFFICE12\mso.dll" \
rename("DocumentProperties", "DocumentPropertiesXL") \
rename("RGB", "RBGXL")
//Microsoft VBA objects
#import \
"C:\Program Files\Common Files\Microsoft Shared\VBA\VBA6\vbe6ext.olb"
//Excel Application objects

#ifdef  MY_EXCEL_POSITION
#import "D:\OFFICE12\EXCEL.EXE" \
rename("DialogBox", "DialogBoxXL") rename("RGB", "RBGXL") \
rename("DocumentProperties", "DocumentPropertiesXL") \
rename("ReplaceText", "ReplaceTextXL") \
rename("CopyFile", "CopyFileXL") \
exclude("IFont", "IPicture") no_dual_interfaces
#else
#import "C:\Program Files\Microsoft Office\OFFICE12\EXCEL.EXE" \
rename("DialogBox", "DialogBoxXL") rename("RGB", "RBGXL") \
rename("DocumentProperties", "DocumentPropertiesXL") \
rename("ReplaceText", "ReplaceTextXL") \
rename("CopyFile", "CopyFileXL") \
exclude("IFont", "IPicture") no_dual_interfaces
#endif

std::string GetFullPath( const char* szFile );

void TestExcel()
{
	DeleteFile( GetFullPath( "tempTest.csv" ).c_str() );
	CoInitialize(NULL);

	HRESULT hr = S_OK;
	Excel::_ApplicationPtr	xlApp;
	Excel::_WorkbookPtr		xlWorkBook;
	Excel::_WorksheetPtr	xlWorkSheet;
	Excel::RangePtr			range;

	xlApp.CreateInstance(L"Excel.Application");
	xlApp->Visible = false;
	xlWorkBook = xlApp->Workbooks->Open( GetFullPath( "test.xlsx" ).c_str() );

	if( xlWorkBook == NULL )
	{
		assert( 0 && "xlApp->Workbooks->Open error" );
		xlApp->Quit();
		xlApp = NULL;
		CoUninitialize();
	}

	//CSV 
#if  0
	hr = xlWorkBook->SaveAs( GetFullPath( "tempTest.csv" ).c_str(), Excel::xlCSV,
			vtMissing, vtMissing, vtMissing, vtMissing, Excel::xlNoChange,
            vtMissing, vtMissing, vtMissing, vtMissing, vtMissing);
#endif
	
	//ũ Ʈ ϱ
	xlWorkSheet = (Excel::_WorksheetPtr)xlWorkBook->Worksheets->GetItem(1);
	
	//column, row  ϱ
	range = xlWorkSheet->UsedRange;
	int column = range->GetColumns()->Count;
	int row = range->GetRows()->Count;
	
	//Ư б, Int ƴѵ     Ұ
	int intNum0 = range->Cells->GetItem( 4, 1 );
	int intNum1 = range->Item[4][1];
	OutputDebugPrintf( " INT б : %d, %d\n", intNum0, intNum1 );

	_bstr_t bsStr1 = xlWorkSheet->Cells->GetItem( 3, 3 );	LPCSTR psz1 = NULL;
	if( bsStr1.length() != 0 )
		psz1 = bsStr1;
	_bstr_t bsStr2 = xlWorkSheet->Cells->Item[3][3];		LPCSTR psz2 = NULL;
	if( bsStr2.length() != 0 )
		psz2 = bsStr2;


	//Ư ϱ
	range->Item[3][1] = "ѱۿ";
		
	xlWorkBook->Save();

	if( FAILED(hr) )
	{
		assert( 0 && "xlWorkBook->SaveAs error" );
	}

	xlWorkBook->Close( VARIANT_FALSE ); 
	xlApp->Quit();

	range = NULL;
	xlWorkSheet = NULL;
	xlWorkBook = NULL;
	xlApp = NULL;
	CoUninitialize();	
}
//-------------------------------------------------------------------------------------------
#include "MyExcel.h"
#include "StringTable.h"

//-------------------------------------------------------------------------------------------
MyExcel::MyExcel()
{
}
//-------------------------------------------------------------------------------------------
MyExcel::~MyExcel()
{
	m_table.Clear();
}
//-------------------------------------------------------------------------------------------
bool MyExcel::Load( const char* szFileName )
{
	CoInitialize(NULL);

	HRESULT hr = S_OK;
	Excel::_ApplicationPtr	xlApp;
	Excel::_WorkbookPtr		xlWorkBook;
	Excel::_WorksheetPtr	xlWorkSheet;
	Excel::RangePtr			range;

	xlApp.CreateInstance(L"Excel.Application");
	xlApp->Visible = false;
	xlWorkBook = xlApp->Workbooks->Open( szFileName );

	if( xlWorkBook == NULL )
	{
		assert( 0 && "xlApp->Workbooks->Open error" );
		xlApp->Quit();
		xlApp = NULL;
		CoUninitialize();
		return false;
	}

	//ũ Ʈ ϱ
	xlWorkSheet = (Excel::_WorksheetPtr)xlWorkBook->Worksheets->GetItem(1);

	//column, row  ϱ
	range = xlWorkSheet->UsedRange;
	int column = range->GetColumns()->Count;
	int row = range->GetRows()->Count;

	m_table.Assign( row, column );
	for( int k = 0; k < row; ++k )
	{
		for( int m = 0; m < column; ++m )
		{
			_bstr_t bsStr1 = xlWorkSheet->Cells->GetItem( k+1, m+1 );	
			if( bsStr1.length() != 0 )
				m_table.Set( k, m, bsStr1, false );	
		}
	}

	xlWorkBook->Close( VARIANT_FALSE ); 
	xlApp->Quit();

	range = NULL;
	xlWorkSheet = NULL;
	xlWorkBook = NULL;
	xlApp = NULL;
	CoUninitialize();
	m_szFileName = szFileName;
	return true;
}
//-------------------------------------------------------------------------------------------
bool MyExcel::Save()
{
	const char* szFileName = m_szFileName.c_str();
	CoInitialize(NULL);

	HRESULT hr = S_OK;
	Excel::_ApplicationPtr	xlApp;
	Excel::_WorkbookPtr		xlWorkBook;
	Excel::_WorksheetPtr	xlWorkSheet;
	Excel::RangePtr			range;

	xlApp.CreateInstance(L"Excel.Application");
	xlApp->Visible = false;
	xlWorkBook = xlApp->Workbooks->Open( szFileName );

	if( xlWorkBook == NULL )
	{
		assert( 0 && "xlApp->Workbooks->Open error" );
		xlApp->Quit();
		xlApp = NULL;
		CoUninitialize();
		return false;
	}

	//ũ Ʈ ϱ
	xlWorkSheet = (Excel::_WorksheetPtr)xlWorkBook->Worksheets->GetItem(1);

	range = xlWorkSheet->UsedRange;

	int rowSize = m_table.GetRowCount();
	for( int k = 0; k < rowSize; ++k )
	{
		int colSize = m_table.GetColumnCount();
		for( int m = 0; m < colSize; ++m )
		{
			StringBoolTable::StringSt* stringSt = m_table.Get( k, m );	
			if( stringSt && stringSt->bDirty ) 
			{
				if( stringSt->string.empty() == true )
					range->Item[k+1][m+1] = "";
				else
					range->Item[k+1][m+1] = stringSt->string.c_str();
			}
		}
	}

	xlWorkBook->Save();
	xlWorkBook->Close( VARIANT_FALSE ); 
	xlApp->Quit();

	range = NULL;
	xlWorkSheet = NULL;
	xlWorkBook = NULL;
	xlApp = NULL;
	CoUninitialize();
	return true;
}
//-------------------------------------------------------------------------------------------
bool MyExcel::SaveAs( const char* szNewFileName )
{
	const char* szFileName = m_szFileName.c_str();
	CoInitialize(NULL);

	HRESULT hr = S_OK;
	Excel::_ApplicationPtr	xlApp;
	Excel::_WorkbookPtr		xlWorkBook;
	Excel::_WorksheetPtr	xlWorkSheet;
	Excel::RangePtr			range;

	xlApp.CreateInstance(L"Excel.Application");
	xlApp->Visible = false;
	xlWorkBook = xlApp->Workbooks->Open( szFileName );

	if( xlWorkBook == NULL )
	{
		assert( 0 && "xlApp->Workbooks->Open error" );
		xlApp->Quit();
		xlApp = NULL;
		CoUninitialize();
		return false;
	}

	//ũ Ʈ ϱ
	xlWorkSheet = (Excel::_WorksheetPtr)xlWorkBook->Worksheets->GetItem(1);

	range = xlWorkSheet->UsedRange;

	int rowSize = m_table.GetRowCount();
	for( int k = 0; k < rowSize; ++k )
	{
		int colSize = m_table.GetColumnCount();
		for( int m = 0; m < colSize; ++m )
		{
			StringBoolTable::StringSt* stringSt = m_table.Get( k, m );	
			if( stringSt && stringSt->bDirty )
			{
				if( stringSt->string.empty() == true )
					range->Item[k+1][m+1] = "";
				else
					range->Item[k+1][m+1] = stringSt->string.c_str();
			}
		}
	}

	// Ȯ ̸    
	_variant_t fileFormat = Excel::xlExcel8;
	if( strstr( szNewFileName, ".csv" ) || strstr( szNewFileName, ".CSV" ) )
		fileFormat = Excel::xlCSV;
	else if( strstr( szNewFileName, ".xlsx" ) || strstr( szNewFileName, ".xlsx" ) )
		fileFormat = Excel::xlOpenXMLWorkbook;

	DeleteFile( szNewFileName );
	xlWorkBook->SaveAs( szNewFileName, fileFormat,
			vtMissing, vtMissing, vtMissing, vtMissing, Excel::xlNoChange,
            vtMissing, vtMissing, vtMissing, vtMissing, vtMissing);

	xlWorkBook->Close( VARIANT_FALSE ); 
	xlApp->Quit();

	range = NULL;
	xlWorkSheet = NULL;
	xlWorkBook = NULL;
	xlApp = NULL;
	CoUninitialize();
	return true;
}
//-------------------------------------------------------------------------------------------
